<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/object-0.29.0/src/archive.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>archive.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../object/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../object/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../object/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
</pre><pre class="rust"><code><span class="doccomment">//! Archive definitions.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! These definitions are independent of read/write support, although we do implement</span>
<span class="doccomment">//! some traits useful for those.</span>

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::pod::Pod</span>;

<span class="doccomment">/// File identification bytes stored at the beginning of the file.</span>
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">MAGIC</span>: [<span class="ident">u8</span>; <span class="number">8</span>] <span class="op">=</span> <span class="kw-2">*</span><span class="string">b&quot;!&lt;arch&gt;\n&quot;</span>;

<span class="doccomment">/// File identification bytes stored at the beginning of a thin archive.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// A thin archive only contains a symbol table and file names.</span>
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">THIN_MAGIC</span>: [<span class="ident">u8</span>; <span class="number">8</span>] <span class="op">=</span> <span class="kw-2">*</span><span class="string">b&quot;!&lt;thin&gt;\n&quot;</span>;

<span class="doccomment">/// The terminator for each archive member header.</span>
<span class="kw">pub</span> <span class="kw">const</span> <span class="ident">TERMINATOR</span>: [<span class="ident">u8</span>; <span class="number">2</span>] <span class="op">=</span> <span class="kw-2">*</span><span class="string">b&quot;`\n&quot;</span>;

<span class="doccomment">/// The header at the start of an archive member.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>)]</span>
<span class="attribute">#[<span class="ident">repr</span>(<span class="ident">C</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Header</span> {
    <span class="doccomment">/// The file name.</span>
    <span class="kw">pub</span> <span class="ident">name</span>: [<span class="ident">u8</span>; <span class="number">16</span>],
    <span class="doccomment">/// File modification timestamp in decimal.</span>
    <span class="kw">pub</span> <span class="ident">date</span>: [<span class="ident">u8</span>; <span class="number">12</span>],
    <span class="doccomment">/// User ID in decimal.</span>
    <span class="kw">pub</span> <span class="ident">uid</span>: [<span class="ident">u8</span>; <span class="number">6</span>],
    <span class="doccomment">/// Group ID in decimal.</span>
    <span class="kw">pub</span> <span class="ident">gid</span>: [<span class="ident">u8</span>; <span class="number">6</span>],
    <span class="doccomment">/// File mode in octal.</span>
    <span class="kw">pub</span> <span class="ident">mode</span>: [<span class="ident">u8</span>; <span class="number">8</span>],
    <span class="doccomment">/// File size in decimal.</span>
    <span class="kw">pub</span> <span class="ident">size</span>: [<span class="ident">u8</span>; <span class="number">10</span>],
    <span class="doccomment">/// Must be equal to `TERMINATOR`.</span>
    <span class="kw">pub</span> <span class="ident">terminator</span>: [<span class="ident">u8</span>; <span class="number">2</span>],
}

<span class="macro">unsafe_impl_pod!</span>(<span class="ident">Header</span>);
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="object" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>